#include <iostream>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin>>n>>q;
    long long d[n];
    int p[n];
    for (int i=0; i<n; i++) {
        cin>>d[i]>>p[i];
    }
    long long upiti[q];
    for (int i=0; i<q; i++) {
        cin>>upiti[i];
    }
    int prev=0;
    int trenutnoKolaca = 0;
    int j=0;
    int k=0;
    for (long long i=1; i<=upiti[q-1]; i++) {
        if (d[j]==i) {
            trenutnoKolaca+=p[j];
            j++;
        }
        if (trenutnoKolaca > 0) {
            prev++;
            trenutnoKolaca--;
        }
        if (upiti[k]==i) {
            cout<<prev<<endl;
            k++;
        }
    }
    return 0;
}